Attribute VB_Name = "DLLDef"
'-----------------------------------------------------------------------
'       aisa04.bas
'
'       AISA-P04W/H Win32 API.
'-----------------------------------------------------------------------

Option Explicit

' װ
Global Const AISA04_SUCCESS = 0                 ' ُȂ
Global Const AISA04_ERR_SYSTEM = 1              ' GetLastError sĂ
Global Const AISA04_ERR_NO_DEVICE = 2           ' gۯĂȂ
Global Const AISA04_ERR_IN_USE = 3              ' w肳ꂽۯĂ͎gp
Global Const AISA04_ERR_INVALID_SLOT = 4        ' sȽۯĔԍw
Global Const AISA04_ERR_INVALID_PORT = 6        ' sȃ|[gv
Global Const AISA04_ERR_INVALID_ARGUMENT = 7    ' sȈv

' ߰Ė
Global Const AISA04_PPI1_A = 0                  ' PPI1 Port A
Global Const AISA04_PPI1_B = 1                  ' PPI1 Port B
Global Const AISA04_PPI1_C = 2                  ' PPI1 Port C
Global Const AISA04_PPI1_CTL = 3                ' PPI1 Control Port

Global Const AISA04_PPI2_A = 4                  ' PPI2 Port A
Global Const AISA04_PPI2_B = 5                  ' PPI2 Port B
Global Const AISA04_PPI2_C = 6                  ' PPI2 Port C
Global Const AISA04_PPI2_CTL = 7                ' PPI2 Control Port

' aISA-04W p
Global Const AISA04_PPI3_A = 8                  ' PPI3 Port A
Global Const AISA04_PPI3_B = 9                  ' PPI3 Port B
Global Const AISA04_PPI3_C = 10                 ' PPI3 Port C
Global Const AISA04_PPI3_CTL = 11               ' PPI3 Control Port

Global Const AISA04_PPI4_A = 12                 ' PPI4 Port A
Global Const AISA04_PPI4_B = 13                 ' PPI4 Port B
Global Const AISA04_PPI4_C = 14                 ' PPI4 Port C
Global Const AISA04_PPI4_CTL = 15               ' PPI4 Control Port

' ̑
Global Const AISA04_MAX_SLOTS = 16             ' Maximum number of slots

Global Const AISA04_SLOT_AUTO = &HFFFF


' ؿ\̗p
Global Const AISA04_MAX_MEM = 9
Global Const AISA04_MAX_IO = 20
Global Const AISA04_MAX_IRQ = 7
Global Const AISA04_MAX_DMA = 7

Type AISA04RESOURCE
    dwNumMemWindows As Long                         ' Not used
    dwMemBase(1 To AISA04_MAX_MEM) As Long          ' Not used
    dwMemLength(1 To AISA04_MAX_MEM) As Long        ' Not used
    dwMemAttrib(1 To AISA04_MAX_MEM) As Long        ' Not used
    dwNumIOPorts As Long                            ' Num IO ports
    dwIOPortBase(1 To AISA04_MAX_IO) As Long        ' I/O port base
    dwIOPortLength(1 To AISA04_MAX_IO) As Long      ' I/O port length
    dwNumIRQs As Long                               ' Num IRQ info
    dwIRQRegisters(1 To AISA04_MAX_IRQ) As Long     ' IRQ list
    dwIRQAttrib(1 To AISA04_MAX_IRQ) As Long        ' IRQ Attrib list
    dwNumDMAs As Long                               ' Not used
    dwDMALst(1 To AISA04_MAX_DMA) As Long           ' Not used
    dwDMAAttrib(1 To AISA04_MAX_DMA) As Long        ' Not used
    dwReserved1(1 To 3) As Long                     ' Not used
End Type

Declare Function Aisa04GetVersion Lib "aisa04" (pdwDll As Long, pdwDrv As Long) As Long
Declare Function Aisa04Create Lib "aisa04" (pwLogSlot As Integer) As Long
Declare Function Aisa04Close Lib "aisa04" (ByVal wLogSlot As Integer) As Long
Declare Function Aisa04GetResource Lib "aisa04" (ByVal wLogSlot As Integer, pres As AISA04RESOURCE) As Long
Declare Function Aisa04InPort Lib "aisa04" (ByVal wLogSlot As Integer, ByVal dwPort As Long, pbValue As Byte) As Long
Declare Function Aisa04OutPort Lib "aisa04" (ByVal wLogSlot As Integer, ByVal dwPort As Long, ByVal bValue As Byte) As Long
Declare Function Aisa04GetLastError Lib "aisa04" (ByVal wLogSlot As Integer) As Long
