/*	aisa04.h

	AISA-P04W/H Win32 API.
*/

#ifndef	AISA04_H
#define	AISA04_H	0x7004

#ifdef	__cplusplus
extern	"C"
{
#endif


// װ
#define AISA04_SUCCESS				0			// ُȂ
#define AISA04_ERR_SYSTEM			1			// GetLastError sĂ
#define AISA04_ERR_NO_DEVICE		2			// gۯĂȂ
#define AISA04_ERR_IN_USE			3			// w肳ꂽۯĂ͎gp
#define AISA04_ERR_INVALID_SLOT		4			// sȽۯĔԍw
#define AISA04_ERR_INVALID_PORT		6			// sȃ|[gv
#define AISA04_ERR_INVALID_ARGUMENT 7			// sȈv

// ߰Ė
#define AISA04_PPI1_A				0			// PPI1 Port A
#define AISA04_PPI1_B				1			// PPI1 Port B
#define AISA04_PPI1_C				2			// PPI1 Port C
#define AISA04_PPI1_CTL				3			// PPI1 Control Port

#define AISA04_PPI2_A				4			// PPI2 Port A
#define AISA04_PPI2_B				5			// PPI2 Port B
#define AISA04_PPI2_C				6			// PPI2 Port C
#define AISA04_PPI2_CTL				7			// PPI2 Control Port

// aISA-04W p
#define AISA04_PPI3_A				8			// PPI3 Port A
#define AISA04_PPI3_B				9			// PPI3 Port B
#define AISA04_PPI3_C				10			// PPI3 Port C
#define AISA04_PPI3_CTL				11			// PPI3 Control Port

#define AISA04_PPI4_A				12			// PPI4 Port A
#define AISA04_PPI4_B				13			// PPI4 Port B
#define AISA04_PPI4_C				14			// PPI4 Port C
#define AISA04_PPI4_CTL				15			// PPI4 Control Port

// ̑
#define AISA04_MAX_SLOTS	16					// ߰Ă޲̍ő吔

#define AISA04_SLOT_AUTO	((WORD) ~0U)		// ۯĂƂ̷ܰ

// ؿ\̗p
#define AISA04_MAX_MEM				9
#define AISA04_MAX_IO				20
#define AISA04_MAX_IRQ				7
#define AISA04_MAX_DMA				7

typedef	struct	_AISA04RESOURCE
{
	DWORD	dwNumMemWindows;					// س޳			gp
	DWORD	dwMemBase		[AISA04_MAX_MEM];	// س޳ްڽ	gp
	DWORD	dwMemLength		[AISA04_MAX_MEM];	// س޳			gp
	DWORD	dwMemAttrib		[AISA04_MAX_MEM];	// س޳		gp
	DWORD	dwNumIOPorts;						// I/O߰Đ
	DWORD	dwIOPortBase	[AISA04_MAX_IO];	// I/O߰ްڽ
	DWORD	dwIOPortLength	[AISA04_MAX_IO];	// I/O߰Ē
	DWORD	dwNumIRQs;							// IRQ				gp
	DWORD	dwIRQRegisters	[AISA04_MAX_IRQ];	// IRQؽ				gp
	DWORD	dwIRQAttrib		[AISA04_MAX_IRQ];	// IRQؽ			gp
	DWORD	dwNumDMAs;							// DMAِ			gp
	DWORD	dwDMALst		[AISA04_MAX_DMA];	// DMAؽ			gp
	DWORD	dwDMAAttrib		[AISA04_MAX_DMA];	// DMAّؽ		gp
	DWORD	dwReserved1		[3];				// \					gp
}	AISA04RESOURCE;

typedef	AISA04RESOURCE		*	PAISA04R;
typedef	AISA04RESOURCE	FAR	*	LPAISA04R;

#ifndef	AISA04_API
#define	AISA04_API	1

#ifndef	AISA04_DS
#define	AISA04_DS	__declspec(dllimport)
#endif

AISA04_DS
BOOL	WINAPI Aisa04GetVersion(PDWORD pdwDll, PDWORD pdwDrv);
AISA04_DS
BOOL	WINAPI Aisa04Create(PWORD pwLogSlot);
AISA04_DS
BOOL	WINAPI Aisa04Close(WORD wLogSlot);
AISA04_DS
BOOL	WINAPI Aisa04GetResource(WORD wLogSlot, PAISA04R pres);
AISA04_DS
BOOL	WINAPI Aisa04InPort(WORD wLogSlot, DWORD dwPort, PBYTE pbValue);
AISA04_DS
BOOL	WINAPI Aisa04OutPort(WORD wLogSlot, DWORD dwPort, BYTE bValue);
AISA04_DS
DWORD	WINAPI Aisa04GetLastError(WORD wLogSlot);

#endif	/* #ifndef	AISA04_API */

#ifdef	__cplusplus
}
#endif

#endif	/* #ifndef	AISA04_H */
